VERSION 5.00
Begin VB.UserControl mdpBar 
   BackColor       =   &H00C0C0C0&
   BackStyle       =   0  'Transparent
   ClientHeight    =   660
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2085
   PropertyPages   =   "mdpBar.ctx":0000
   ScaleHeight     =   660
   ScaleWidth      =   2085
   Begin VB.PictureBox picTablo 
      Height          =   315
      Left            =   30
      ScaleHeight     =   255
      ScaleWidth      =   1905
      TabIndex        =   0
      Top             =   270
      Width           =   1965
      Begin VB.Label lblYuzde 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "%"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   162
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   240
         Left            =   840
         TabIndex        =   1
         Top             =   0
         Width           =   195
      End
      Begin VB.Shape shpProgres 
         BackStyle       =   1  'Opaque
         FillColor       =   &H0000FF00&
         FillStyle       =   0  'Solid
         Height          =   195
         Left            =   60
         Top             =   30
         Width           =   45
      End
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      Caption         =   "mdpBar"
      Height          =   195
      Left            =   60
      TabIndex        =   2
      Top             =   30
      Width           =   540
   End
End
Attribute VB_Name = "mdpBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Public Enum eSlide
   eVertical
   eHorizontal
End Enum

Public Enum eAnimate
   eFixed
   eIn
   eOut
End Enum

'Default Property Values:
Const m_def_Animate = eAnimate.eFixed
Const m_def_BackColor = &H8000000F
Const m_def_Slide = eSlide.eHorizontal
Const m_def_CaptionFColor = 0
Const m_def_CaptionBColor = &H8000000F
Const m_def_Frame = 0
Const m_def_Caption = "PBar"
Const m_def_CaptionVisible = False
Const m_def_CaptionAlingment = AlignmentConstants.vbLeftJustify
Const m_def_ForeColor = 0
Const m_def_BarColor = &HFF00&
Const m_def_Value = 0
Const m_def_Max = 0
'Property Variables:
Dim m_Animate As eAnimate
Dim m_BackColor As OLE_COLOR
Dim m_Slide As eSlide
Dim m_CaptionFColor As OLE_COLOR
Dim m_CaptionBColor As OLE_COLOR
Dim m_Frame As Boolean
Dim m_Caption As String
Dim m_CaptionVisible As Boolean
Dim m_CaptionAlingment As AlignmentConstants
Dim m_ForeColor As OLE_COLOR
Dim m_BarColor As OLE_COLOR
Dim m_Value As Long
Dim m_Font As Font
Dim m_Max As Long
'

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=6,0,0,0
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
   Set Font = m_Font
End Property

Public Property Set Font(ByVal New_Font As Font)
   Set m_Font = New_Font
   PropertyChanged "Font"
   Call Refresh
   Call UserControl_Resize
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get Max() As Long
Attribute Max.VB_ProcData.VB_Invoke_Property = "Genel"
   Max = m_Max
End Property

Public Property Let Max(ByVal New_Max As Long)
   m_Max = New_Max
   PropertyChanged "Max"
   SetSize
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
   Set m_Font = Ambient.Font
   m_Max = m_def_Max
   m_Value = m_def_Value
   Value = 50
   Max = 100
   m_BarColor = m_def_BarColor
   m_ForeColor = m_def_ForeColor
   m_Caption = m_def_Caption
   m_CaptionVisible = m_def_CaptionVisible
   m_CaptionAlingment = m_def_CaptionAlingment
   m_Frame = m_def_Frame
   m_CaptionFColor = m_def_CaptionFColor
   m_CaptionBColor = m_def_CaptionBColor
   m_BackColor = m_def_BackColor
   m_Slide = m_def_Slide
   Call UserControl_Resize
   m_Animate = m_def_Animate
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   Set m_Font = PropBag.ReadProperty("Font", Ambient.Font)
   m_Max = PropBag.ReadProperty("Max", m_def_Max)
   m_Value = PropBag.ReadProperty("Value", m_def_Value)
   m_BarColor = PropBag.ReadProperty("BarColor", m_def_BarColor)
   m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
   m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
   m_CaptionVisible = PropBag.ReadProperty("CaptionVisible", m_def_CaptionVisible)
   m_CaptionAlingment = PropBag.ReadProperty("CaptionAlingment", m_def_CaptionAlingment)
   m_Frame = PropBag.ReadProperty("Frame", m_def_Frame)
   m_CaptionFColor = PropBag.ReadProperty("CaptionFColor", m_def_CaptionFColor)
   m_CaptionBColor = PropBag.ReadProperty("CaptionBColor", m_def_CaptionBColor)
   m_BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
   m_Slide = PropBag.ReadProperty("Slide", m_def_Slide)
   m_Animate = PropBag.ReadProperty("Animate", m_def_Animate)
End Sub

Private Sub UserControl_Resize()
On Error Resume Next
   With picTablo
      .Width = Width - 80
      .Height = Height - IIf(CaptionVisible, 80 + lblCaption.Height, 20)
      If Not CaptionVisible Then
         .Top = 0
      Else
         .Top = lblCaption.Height + 55
      End If
   End With
   With shpProgres
      .Width = picTablo.Width - 150
      .Height = picTablo.Height - 100
   End With
   SetSize
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
   Call PropBag.WriteProperty("Font", m_Font, Ambient.Font)
   Call PropBag.WriteProperty("Max", m_Max, m_def_Max)
   Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
   Call PropBag.WriteProperty("BarColor", m_BarColor, m_def_BarColor)
   Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
   Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
   Call PropBag.WriteProperty("CaptionVisible", m_CaptionVisible, m_def_CaptionVisible)
   Call PropBag.WriteProperty("CaptionAlingment", m_CaptionAlingment, m_def_CaptionAlingment)
   Call PropBag.WriteProperty("Frame", m_Frame, m_def_Frame)
   Call PropBag.WriteProperty("CaptionFColor", m_CaptionFColor, m_def_CaptionFColor)
   Call PropBag.WriteProperty("CaptionBColor", m_CaptionBColor, m_def_CaptionBColor)
   Call PropBag.WriteProperty("BackColor", m_BackColor, m_def_BackColor)
   Call PropBag.WriteProperty("Slide", m_Slide, m_def_Slide)
   Call PropBag.WriteProperty("Animate", m_Animate, m_def_Animate)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=8,0,0,0
Public Property Get Value() As Long
Attribute Value.VB_ProcData.VB_Invoke_Property = "Genel"
   Value = m_Value
End Property

Public Property Let Value(ByVal New_Value As Long)
   m_Value = New_Value
   PropertyChanged "Value"
   Call SetSize
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BarColor() As OLE_COLOR
   BarColor = m_BarColor
End Property

Public Property Let BarColor(ByVal New_BarColor As OLE_COLOR)
   m_BarColor = New_BarColor
   PropertyChanged "BarColor"
   Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get ForeColor() As OLE_COLOR
   ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
   m_ForeColor = New_ForeColor
   PropertyChanged "ForeColor"
   Refresh
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,PBar
Public Property Get Caption() As String
Attribute Caption.VB_ProcData.VB_Invoke_Property = "Genel"
   Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
   m_Caption = New_Caption
   PropertyChanged "Caption"
   Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=14,0,0,0
Public Property Get CaptionVisible() As Boolean
Attribute CaptionVisible.VB_ProcData.VB_Invoke_Property = "Genel"
   CaptionVisible = m_CaptionVisible
End Property

Public Property Let CaptionVisible(ByVal New_CaptionVisible As Boolean)
   m_CaptionVisible = New_CaptionVisible
   PropertyChanged "CaptionVisible"
   Call UserControl_Resize
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get CaptionAlingment() As AlignmentConstants
   CaptionAlingment = m_CaptionAlingment
End Property

Public Property Let CaptionAlingment(ByVal New_CaptionAlingment As AlignmentConstants)
   m_CaptionAlingment = New_CaptionAlingment
   PropertyChanged "CaptionAlingment"
   Call UserControl_Resize
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get Frame() As Boolean
Attribute Frame.VB_ProcData.VB_Invoke_Property = "Genel"
   Frame = m_Frame
End Property

Public Property Let Frame(ByVal New_Frame As Boolean)
   m_Frame = New_Frame
   PropertyChanged "Frame"
   Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get CaptionFColor() As OLE_COLOR
   CaptionFColor = m_CaptionFColor
End Property

Public Property Let CaptionFColor(ByVal New_CaptionFColor As OLE_COLOR)
   m_CaptionFColor = New_CaptionFColor
   PropertyChanged "CaptionFColor"
   Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get CaptionBColor() As OLE_COLOR
   CaptionBColor = m_CaptionBColor
End Property

Public Property Let CaptionBColor(ByVal New_CaptionBColor As OLE_COLOR)
   m_CaptionBColor = New_CaptionBColor
   PropertyChanged "CaptionBColor"
   Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H8000000F&
Public Property Get BackColor() As OLE_COLOR
   BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
   m_BackColor = New_BackColor
   PropertyChanged "BackColor"
   Refresh
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get Slide() As eSlide
   Slide = m_Slide
End Property

Public Property Let Slide(ByVal New_Slide As eSlide)
   m_Slide = New_Slide
   PropertyChanged "Slide"
   Call UserControl_Resize
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get Animate() As eAnimate
   Animate = m_Animate
End Property

Public Property Let Animate(ByVal New_Animate As eAnimate)
   m_Animate = New_Animate
   PropertyChanged "Animate"
   SetSize
End Property

Private Sub SetSize()
   Dim lngSinir As Long
   '
   If Slide = eHorizontal Then
      lngSinir = picTablo.Width - 150
   Else
      lngSinir = picTablo.Height - 150
   End If
   If lngSinir > 0 And Max > 0 And Value > 0 Then
      If Value < Max Then
         If Slide = eHorizontal Then
            With shpProgres
               .Top = 60
               .Width = lngSinir / (Max / Value)
               .Height = picTablo.Height - 150
            End With
         Else
            With shpProgres
               .Width = picTablo.Width - 150
               .Height = lngSinir / (Max / Value) + 20
               .Top = lngSinir - shpProgres.Height + 80
            End With
         End If
         lblYuzde.Caption = "% " + CStr(Round(Value * (100 / Max)))
      Else
         If Slide = eHorizontal Then
            With shpProgres
               .Top = 60
               .Width = lngSinir
               .Height = picTablo.Height - 150
            End With
         Else
            With shpProgres
               .Width = picTablo.Width - 150
               .Height = lngSinir
               .Top = lngSinir - shpProgres.Height + 60
            End With
         End If
         lblYuzde.Caption = "% 100"
      End If
   Else
      If Max <= 0 Then Max = 1
      If Value <= 0 Then Value = 1
   End If
   Refresh
End Sub

Private Sub Refresh()
   picTablo.BackColor = BackColor
   shpProgres.FillColor = BarColor
   With lblYuzde
      If Slide = eHorizontal Then
         If Animate = eOut Then
            If shpProgres.Width + .Width < picTablo.Width - 20 Then
               .Left = shpProgres.Width + 20
            Else
               .Left = ((picTablo.Width - .Width) / 2) - 20
            End If
         Else
            If Animate = eIn Then
               .Left = ((IIf(Max > Value, shpProgres.Width, picTablo.Width) - .Width) / 2) - 20
            Else
               .Left = ((picTablo.Width - .Width) / 2) - 20
            End If
         End If
         .Top = ((picTablo.Height - .Height) / 2) - 20
      Else
         If Animate = eOut Then
            If shpProgres.Height + .Height < picTablo.Height - 20 Then
               .Top = shpProgres.Top - .Height - 20
            Else
               .Top = (picTablo.Height - .Height) / 2
            End If
         Else
            If Animate = eIn Then
               If Max > Value Then
                  .Top = shpProgres.Top + (shpProgres.Height - .Height) / 2
               Else
                  .Top = (picTablo.Height - .Height) / 2
               End If
            Else
               .Top = ((picTablo.Height - .Height) / 2) - 20
            End If
         End If
         .Left = ((picTablo.Width - .Width) / 2) - 20
      End If
      '
      .ForeColor = ForeColor
      .Font.Bold = Font.Bold
      .Font.Charset = Font.Charset
      .Font.Italic = Font.Italic
      .Font.Name = Font.Name
      .Font.Size = Font.Size
      .Font.Strikethrough = Font.Strikethrough
      .Font.Underline = Font.Underline
      .Font.Weight = Font.Weight
   End With
   With lblCaption
      .Caption = Caption
      .Alignment = CaptionAlingment
      .Visible = CaptionVisible
      .Left = picTablo.Left + 20
      .Width = picTablo.Width - 30
      '
      .ForeColor = CaptionFColor
      .BackColor = CaptionBColor
      .Font.Bold = Font.Bold
      .Font.Charset = Font.Charset
      .Font.Italic = Font.Italic
      .Font.Name = Font.Name
      .Font.Size = Font.Size
      .Font.Strikethrough = Font.Strikethrough
      .Font.Underline = Font.Underline
      .Font.Weight = Font.Weight
   End With
   shpProgres.BorderStyle = IIf(Frame, 1, 0)
End Sub
